package com.engine.salary.mapper.salaryacct;

import com.engine.salary.entity.salaryacct.po.SalaryAcctResultPO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

public interface SalaryAcctResultMapper {

	/**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
	List<SalaryAcctResultPO> listAll();
    
    /**
     * 条件查询
     *
     * @return 返回集合，没有返回空List
     */
    List<SalaryAcctResultPO> listSome(SalaryAcctResultPO salaryAcctResult);
    

	/**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
	SalaryAcctResultPO getById(Long id);
	
	/**
     * 新增，忽略null字段
     *
     * @param salaryAcctResult 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(SalaryAcctResultPO salaryAcctResult);
	
	/**
     * 修改，修改所有字段
     *
     * @param salaryAcctResult 修改的记录
     * @return 返回影响行数
     */
	int update(SalaryAcctResultPO salaryAcctResult);
	
	/**
     * 修改，忽略null字段
     *
     * @param salaryAcctResult 修改的记录
     * @return 返回影响行数
     */
	int updateIgnoreNull(SalaryAcctResultPO salaryAcctResult);
	
	/**
     * 删除记录
     *
     * @param salaryAcctResult 待删除的记录
     * @return 返回影响行数
     */
	int delete(SalaryAcctResultPO salaryAcctResult);


	/**
	 * 查询同一个薪资所属月内的所有核算结果
	 *
	 * @param salaryAcctRecordIds
	 * @param tenantKey
	 * @return
	 */
	List<SalaryAcctResultPO> listSameSalaryMonthResult(@Param("salaryAcctRecordIds") Collection<Long> salaryAcctRecordIds,
													   @Param("tenantKey") String tenantKey);

	/**
	 * 批量新增
	 *
	 * @param salaryAccountingResults
	 */
	void batchInsert(@Param("collection") Collection<SalaryAcctResultPO> salaryAccountingResults);

	/**
	 * 根据薪资核算id删除薪资核算结果
	 *
	 * @param salaryAcctRecordIds
	 */
	void deleteBySalaryAcctRecordIds(@Param("salaryAcctRecordIds") Collection<Long> salaryAcctRecordIds);

	/**
	 * 根据薪资核算id删除薪资核算结果
	 *
	 * @param salaryAcctEmpIds
	 */
	void deleteBySalaryAcctEmpIds(@Param("salaryAcctEmpIds") Collection<Long> salaryAcctEmpIds);

	/**
	 * 根据薪资核算人员id、薪资项目id删除薪资核算结果
	 *
	 * @param salaryAcctEmpIds
	 * @param salaryItemIds
	 */
	void deleteByAcctEmpIdsAndSalaryItemIds(@Param("salaryAcctEmpIds") List<Long> salaryAcctEmpIds,
											@Param("salaryItemIds") Collection<Long> salaryItemIds);

	/**
	 *
	 * @param salaryAcctRecordId
	 * @param salaryItemIds
	 */
	void deleteBySalaryAcctRecordIdAndSalaryItemIds(@Param("salaryAcctRecordId") Long salaryAcctRecordId,
											@Param("salaryItemIds") Collection<Long> salaryItemIds);

	/**
	 * 根据薪资核算id删除薪资核算结果
	 *
	 * @param ids
	 */
	void deleteByIds(@Param("ids") Collection<Long> ids);

	/**
	 * 批量修改
	 * @param pos
	 */
	int batchUpdate(@Param("collection") List<SalaryAcctResultPO> pos);

	/**
	 * @description 批量更新回算薪资项目
	 * @return null
	 * @author Harryxzy
	 * @date 2022/11/24 21:12
	 */
	void batchUpdateOriginResultValue(@Param("collection") List<SalaryAcctResultPO> subSalaryAcctResultValues);

	List<Long> getAcctEmpIsExist(@Param("empIds")List<Long> empIds);
}